# About JourNote

JourNote is a *proof of concept* journal app with a text user interface and a couple of goals:

- to illustrate creating a minimal app of this type (in Python);
- to explore the use of `dialog` for a day-to-day tool of moderate complexity.

The name is pronounced like in French.

As of March 2024, JourNote is in development, and the state of documentation reflects that. Sorry.

## Requirements

- Python 3.5 or newer
- `dialog` (tested with version 1.3)
- [optional] `grep` (for the search feature)

## Features

- [X] Use external editor if set, else the `dialog` edit box.
- [X] Works in any given directory (current one by default).
- [X] Create journal files by day or by month.
- [X] Pick file extension for journal file (plain text / Markdown).
- [X] Configurable number of entries in listings.

### To do

- [X] Improve workflow for Recent and Search.
- [X] Command-line options.

## Usage

JourNote works with plain text files stored in a directory of your choice (see below). You're free to write whatever you want in these files, and to handle them outside the application.

Normally JourNote creates one file per day, and another for quick notes, all named accordingly. Entries can be listed or searched from within the application; older files can be moved to an archive directory.

To achieve this, JourNote uses a TUI (text user interface). All available commands are shown in the main menu.

## Configuration

### Environment variables

- `EDITOR` sets the text editor to use (default: internal)
- `VISUAL` is a fallback option for `EDITOR`
- `JNDIR` sets the working directory (default: current)

### Config file

JourNote has some options that can be set. For now the only way is to manually create a file in the working directory called `journote.ini`, with contents along these lines:

```ini
[JourNote]
file_ext = .txt
file_limit = 30
# See `man strftime` for details.
date_format = %Y-%m-%d
# Either 0 - Sunday, 1 - Monday... or else Su, Mo, Tu and so on.
week_start = Su
```

Those are all the options supported as of version 0.9 alpha, with default values (the order doesn't matter).

### Option menu

As of version 1.0 beta, JourNote includes an option menu. It offers less freedom than manually editing the config file, but should be easier to use.

Remember to save if you want your configuration changes to be preserved.

## License and support

JourNote is open source under the MIT License. See source code for details.

if you have any problems, it's best to open an issue on [Codeberg][].

[Codeberg]: https://codeberg.org/nosycat/journote
